const $ = require('jquery');
require("../css/reset.less")
require("../css/deptConsole.less")
require("../images/logo.png")
require("../images/arrow_down.png")

// import 'zrender/lib/svg/svg';
const {api} = require('./api.js')
const echarts = require('echarts');
const {post,setCookie,delCookie,getCookie} = require('../js/utils.js');
let payMoney = [],dayLis = [],dateType = 2,curDept = '',datafst=[],datasec=[],datatrd=[],datafour=[],hospital=getCookie("hospital");
$(function(){
    if(!hasData('YH-KZT')&&!hasData('YH-KZTKS')){
        $("body").html('')
    }
    if(hospital == "台州市立"){
        $(".circleBSingle").css("display","block")
        $(".circleBLis").css("display","none")
    }else{
        $(".circleBSingle").css("display","none")
        $(".circleBLis").css("display","block")
    }
    $(".partTitle p span").html(hospital)
    setInterval(() => {
        getTimeDetail()
    }, 1000);
    // resizeBox()
    initConsole()//质控列表
    getOwnDept()
    dateChange()
    $(window).click(function(){
        window.parent.userActionHide()
        $(".toggleSlide ul").css("display","none")
    })
                
    $(".toggleSlide p").click(function(e){
        e.stopPropagation()
        $(this).next().slideToggle()
    })

    tiaomu()
})
function tiaomu(){
    $(".defect .partTitlePub").click(function(){
        $(parent.document).find("#contentIframe").attr("src","mukuai.html?from=2&deptName="+curDept+"&dateType="+dateType)
    })
    $(".circleBSingle .title,.homePageNo .title").click(function(){
        $(parent.document).find("#contentIframe").attr("src","tiaomu.html?from=2&deptName="+curDept+"&dateType="+dateType)
    })
    $(".homePage .title").click(function(){
        $(parent.document).find("#contentIframe").attr("src","partDetail.html")
    })
    $(".part02 .bingli,.part02 .bingliLis").click(function(){
        $(parent.document).find("#contentIframe").attr("src","deptScoreDetail.html")
    })
}
//判断有无某一权限
function hasData(data){
    let lis = JSON.parse(getCookie("codeLis"))||[]
    // console.log(lis)
    if(lis.indexOf(data)>-1){//有权限
        return true
    }
    return false;
  }
function resizeBox(){
    $(".partWrap").css({
        height:$(window).height()-38+'px'
    })
}
//所有数据切换日期筛选
function dateChange(){
    $(".monthYear .mon").click(function(){
        $(this).css({
            backgroundColor:'#5A8EEE',
            color:'#fff'
        }).siblings().css({
            color:'#5A8EEE',
            backgroundColor:'#fff'
        })
        dateType = 1
        getBarData(1)
    })
    $(".monthYear .year").click(function(){
        $(this).css({
            backgroundColor:'#5A8EEE',
            color:'#fff'
        }).siblings().css({
            color:'#5A8EEE',
            backgroundColor:'#fff'
        })
        dateType = 2
        getBarData(2)
    })
}

//控制台数
function initConsole(result){
    let url = {
        '本月病历数':require("../images/icon6.png"),
        '本月不合格病历-机器':require("../images/icon7.png"),
        '本月质控数-机器':require("../images/icon10.png"),
        '本月甲级病历-机器':require("../images/icon8.png"),
        '本月乙级病历-机器':require("../images/icon9.png"),
        '本年病历数':require("../images/icon6.png"),
        '本年不合格病历-机器':require("../images/icon7.png"),
        '本年质控数-机器':require("../images/icon10.png"),
        '本年甲级病历-机器':require("../images/icon8.png"),
        '本年乙级病历-机器':require("../images/icon9.png"),
    }
    let dom = '';
    for(let i in result){
        if(i.indexOf("人工")==-1){
            let name = i.split("-")[0];
            let num = 0;
            if(name=='本月病历数'||name=='本年病历数'){
                num = result[i]
            }else{
                num = result[name+'-人工']+result[i]
            }
            dom += `
                <li class="partLi">
                    <div class="partIn">
                        <p class="top">${name}</p>
                        <p class="btm clearfix">
                        <img src="${url[i]}" alt="">
                        <span>${num}</span>
                        </p>
                    </div>
                </li>
            `
        }
    }
    $(".partAll").html(dom)
}
//获取科室列表
function getOwnDept(){
    // if(hasData('FUNC000058')){
        post(api.getDept,{}).then((res)=>{
            let data = res.data;
            if(data.code == 0){
                let result = data.data
                renderDeptLis(result)//科室tab渲染
                curDept = result[0].deptName
                $(".partTitle p i,.toggleSlide p span").html(curDept).attr("title",curDept)
                getBarData(2)//图标数据获取
            }
        })
    // }
}
function renderDeptLis(data){
    let str = ''
    for(let i = 0; i < data.length;i++){
        str += `
            <li title="${data[i].deptName}" class="${i == 0?'li0 toggleAverge toggleSlide1':'toggleAverge toggleSlide1'}" data-dept="${data[i].deptName}">${data[i].deptName}</li>
        `
    }
    $(".toggleSlide ul").html(str)
    $(".toggleSlide ul li").click(function(){
        let name = $(this).attr("data-dept")
        curDept = name
        $(this).parent().slideToggle().prev().find("span").html(name).attr("title",name)
        $(".partTitle p i").html(name).attr("title",name)
        personNum(datafst[name]||[])
        setNumDetail(datasec[name]||[])
        queList(datatrd[name]||[])
        for(let i = 0;i < datafour[name].length;i++){
            datafour[name][i].value = datafour[name][i].num
        }
        emptyCircleB(datafour[name])
        panDetailB(datafour[name])
        $(this).addClass("li0").siblings().removeClass("li0")
    })
}
//获取图表数据
function getBarData(type){
    if(hasData('FUNC000054')){
        post(api.leaveHosCountByDept,{//出院人数统计
            "type": type||1//1月2年
        }).then((res)=>{
            let data = res.data;
            if(data.code == 0){
                let result = data.data[curDept]||[]
                datafst = data.data
                personNum(result)
            }
        })
    }
    if(hasData('FUNC000055')){
        post(api.mrCountByDept,{//质控病历统计
            "type": type||1//1月2年
        }).then((res)=>{
            let data = res.data
            if(data.code == 0){
                let result3 = data.data[curDept]||[]
                datasec = data.data
                setNumDetail(result3)
            }
        })
    }
    if(hasData('FUNC000056')){
        post(api.entryCountGroupByCaseAndDept,{//各模块缺陷占比排行
            "type": type||1//1月2年
        }).then((res)=>{
            let data = res.data;
            if(data.code == 0){
                let result1 = data.data[curDept]||[]
                datatrd = data.data
                queList(result1)
            }
        })
    }
    if(hasData('FUNC000057')){
        if(hospital=="台州市立"){
            post(api.entryCountGroupByEntryAndDept,{//条目缺陷占比
                "type": type||1//1月2年
            }).then((res)=>{
                let data = res.data;
                if(data.code == 0){
                    let result3 = data.data[curDept]||[]
                    for(let i = 0;i < result3.length;i++){
                        result3[i].value = result3[i].num
                    }
                    datafour = data.data
                    emptyCircleB(result3)
                    panDetailB(result3)
                }
            })
        }else{
            post(api.entryCountGroupByEntryAndDept,{//条目缺陷占比
                "type": type||1//1月2年
            }).then((res)=>{
                let data = res.data;
                if(data.code == 0){
                    let result3 = data.data[curDept]||[]
                    for(let i = 0;i < result3.length;i++){
                        result3[i].value = result3[i].num
                    }
                    datafour = data.data
                    emptyCircleBc(result3)
                    panDetailBc(result3)
                }
            })
        }
    }
    if(hospital=="长兴医院"&&hasData("FUNC000076")){
        post(api.getAverageScore,{//病案首页
            "type": type||1//1月2年
        }).then((res)=>{
            let data = res.data;
            if(data.code == 0){
                let result1 = data.data['各科室质控平均分']||[]
                let dataX1=[],dataY1=[]
                for(let i = 0;i < result1.length;i++){
                    dataX1.push(result1[i].name)
                    dataY1.push(result1[i].averageValue)
                }
                lineChartSpecial(dataX1,dataY1)
            }
        })
    }
}
function lineChartSpecial(dataX,dataY){
    var myCharts = echarts.init(document.getElementById('lineChart'));
    var lengthNum = dataX.length;
    $(window).resize(function(){
        myCharts.resize()
    });
    option = {
        color: ['#3398DB'],
        tooltip: {
            trigger: 'axis',
            position: 'right',
            axisPointer: {            // 坐标轴指示器，坐标轴触发有效
                type: 'line'        // 默认为直线，可选为：'line' | 'shadow'
            }
        },
        grid: {
            left: '3%',
            right: '4%',
            bottom: '3%',
            containLabel: true
        },
        xAxis: [
            {
                type: 'category',
                data: dataX,
                axisTick: {
                    alignWithLabel: true
                },
                axisLabel: {//x轴刻度
                    textStyle: {
                        color: '#333'
                    },
                    rotate:45,
                    formatter: function (value) {
                        //x轴的文字改为竖版显示
                        if(value.length>7){
                            return value.slice(0,7)+'...'
                        }
                        return value;
                     }
                },
                axisLine: {//x轴
                    lineStyle:{
                        color:'#AAAAAA'
                    }
                }
            }
        ],
        yAxis: [
            {
                type: 'value',
                axisLine: {//y轴
                    show: false
                },
                axisTick: {
                    show: false
                },
                axisLabel: {//y轴刻度
                    textStyle: {
                        color: '#333333'
                    }
                },
                splitLine:{//分割线
                    lineStyle:{
                        color:'#EFF3FC'
                    }
                }
            }
            
        ],
        title:[{
            text: '合格率',
            top: 15,
            left: 10,
            textStyle: {
                fontSize: 14,
                color:'#666666',
                fontWeight: 400
            }
        }],
        series: [
            {
                name: '质控平均分',
                type: 'bar',
                barWidth: '23%',
                data: dataY
            }
        ]
    };
    myCharts.setOption(option);
}
//part01
function personNum(data){
    $(".personNum").html("总人数："+data['总人数'])
    $(".died").html(data['死亡人数'])
    $(".newborn").html(data['新生儿人数'])
    $(".patientNum").html(data['手术病人数'])
}
//part02
function setNumDetail(data){
    // console.log(data,2222222222)
    if(data.length == 0){
        data = [
            {
                "id":null,
                "name":"累计质控病历数",
                "totleNum":0,
                "num":0,
                "percent":null,
                "percentStr":null
            },
            {
                "id":null,
                "name":"甲级病历",
                "totleNum":10,
                "num":0,
                "percent":0,
                "percentStr":"0.00%"
            },
            {
                "id":null,
                "name":"乙级病历",
                "totleNum":10,
                "num":0,
                "percent":0,
                "percentStr":"0.00%"
            },
            {
                "id":null,
                "name":"丙级病历",
                "totleNum":10,
                "num":0,
                "percent":0,
                "percentStr":"0.00%"
            }
        ]
    }
    let str = ''
    for(let i = 0;i < data.length;i++){
        str += `
            <li class="${i==0?'fst':i == data.length-1?' four':''}">
            <p class="numShow">${data[i].num}</p>
            <p class="explainNum">${data[i].name}</p>
            </li>
        `
        if(data[i].name == '甲级病历'){
            let tmp = []
            data[i].value = data[i].num
            tmp.push(data[i])
            tmp.push({percentStr:(1-data[i].percent)*100+'%',value:data[i].totleNum - data[i].num})
            part02pan(tmp,'fen01')
        }
        if(data[i].name == '乙级病历'){
            let tmp = []
            data[i].value = data[i].num
            tmp.push(data[i])
            tmp.push({percentStr:(1-data[i].percent)*100+'%',value:data[i].totleNum - data[i].num})
            part02pan(tmp,'fen02')
        }
        if(data[i].name == '丙级病历'){
            let tmp = []
            data[i].value = data[i].num
            tmp.push(data[i])
            tmp.push({percentStr:(1-data[i].percent)*100+'%',value:data[i].totleNum - data[i].num})
            part02pan(tmp,'fen03')
        }
    }
    $('.bingli').html(str)
}
//part02pan
function part02pan(data,dom){
    // console.log(data,33333)
    dom = echarts.init(document.getElementById(dom));
    $(window).resize(function(){
        dom.resize()
    });
    let bgColor = '#fff';
    let title = '总量';
    let color = ['#37CBCB','#dedede'];
    let echartData = data;
    option = {
        backgroundColor: bgColor,
        color: color,
        title: [{
            text:'{val|' + echartData[0].percentStr + '}',
            top: 'center',
            left: 'center',
            textStyle: {
                rich: {
                    val: {
                        fontSize: 14,
                        color: '#333',
                        fontWeight: 'bold',
                        padding: [10, 0]
                    },
                    name: {
                        fontSize: 12,
                        fontWeight: 'normal',
                        color: '#777',
                    }
                }
            }
        }],
        series: [{
            name: '',
            type: 'pie',
            radius: ['70%', '90%'],
            data: echartData,
            hoverAnimation:false,
            label: {
                normal: {
                    show:false,
                }
            },
        }]
    };      
    dom.setOption(option);
}
//柱状图住院日期
function emptyCircleB(data){
    var myChart = echarts.init(document.getElementById('emptyCircleB'));
    $(window).resize(function(){
        myChart.resize()
    });
    let bgColor = '#fff';
    let title = '总量';
    let color = ['#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336','#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336'];
    let echartData = data;
    let total = 0;
    for(let i = 0;i < echartData.length;i++){
        total += echartData[i].num
    }
    option = {
        backgroundColor: bgColor,
        color: color,
        title: [{
            text: data.length>0?'{val|' + total + '}\n{name|' + title + '}':'',
            top: 'center',
            left: 'center',
            textStyle: {
                rich: {
                    val: {
                        fontSize: 24,
                        color: '#333',
                        fontWeight: 'bold',
                        padding: [10, 0]
                    },
                    name: {
                        fontSize: 12,
                        fontWeight: 'normal',
                        color: '#777',
                    }
                }
            }
        }],
        tooltip: {
            trigger: 'item',
            position: 'right',
            // formatter: '{b} : {c}  ({d}%)',
            formatter:function(item){
                const {name, num, percentStr} = item.data
                return `${name} : ${num} (${percentStr})`
            }
        },
        series: [{
            name: '',
            type: 'pie',
            radius: ['70%', '90%'],
            data: echartData,
            hoverAnimation:true,
            hoverOffset:5,
            itemStyle: {
                normal: {
                    borderColor: bgColor,
                    borderWidth: 2
                }
            },
            labelLine: {
                normal: {
                    length: 20,
                    length2: 120,
                    lineStyle: {
                        color: '#e6e6e6'
                    }
                }
            },
            label: {
                normal: {
                    show:false,
                    formatter: params => {
                        return params.name == 'A类'?params.name:''
                    },
                    padding: [0 , -100, 25, -100],
                    rich: {
                        icon: {
                            fontSize: 16
                        },
                        name: {
                            fontSize: 14,
                            padding: [0, 10, 0, 4],
                            color: '#666666'
                        },
                        value: {
                            fontSize: 18,
                            fontWeight: 'bold',
                            color: '#333333'
                        }
                    }
                }
            },
        }]
    };      
    myChart.setOption(option);
}
function emptyCircleBc(data){
    var myChart = echarts.init(document.getElementById('emptyCircleBc'));
    $(window).resize(function(){
        myChart.resize()
    });
    let bgColor = '#fff';
    let title = '总量';
    let color = ['#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336','#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336'];
    let echartData = data;
    let total = 0;
    for(let i = 0;i < echartData.length;i++){
        total += echartData[i].num
    }
    option = {
        backgroundColor: bgColor,
        color: color,
        title: [{
            text: data.length>0?'{val|' + total + '}\n{name|' + title + '}':'',
            top: 'center',
            left: 'center',
            textStyle: {
                rich: {
                    val: {
                        fontSize: 24,
                        color: '#333',
                        fontWeight: 'bold',
                        padding: [10, 0]
                    },
                    name: {
                        fontSize: 12,
                        fontWeight: 'normal',
                        color: '#777',
                    }
                }
            }
        }],
        tooltip: {
            trigger: 'item',
            position: 'right',
            // formatter: '{b} : {c}  ({d}%)',
            formatter:function(item){
                const {name, num, percentStr} = item.data
                return `${name} : ${num} (${percentStr})`
            }
        },
        series: [{
            name: '',
            type: 'pie',
            radius: ['70%', '90%'],
            data: echartData,
            hoverAnimation:true,
            hoverOffset:5,
            itemStyle: {
                normal: {
                    borderColor: bgColor,
                    borderWidth: 2
                }
            },
            labelLine: {
                normal: {
                    length: 20,
                    length2: 120,
                    lineStyle: {
                        color: '#e6e6e6'
                    }
                }
            },
            label: {
                normal: {
                    show:false,
                    formatter: params => {
                        return params.name == 'A类'?params.name:''
                    },
                    padding: [0 , -100, 25, -100],
                    rich: {
                        icon: {
                            fontSize: 16
                        },
                        name: {
                            fontSize: 14,
                            padding: [0, 10, 0, 4],
                            color: '#666666'
                        },
                        value: {
                            fontSize: 18,
                            fontWeight: 'bold',
                            color: '#333333'
                        }
                    }
                }
            },
        }]
    };      
    myChart.setOption(option);
}
//缺陷列表渲染
function queList(data){
    let strAll = '',tmp = `mm
        <tr class="thead">
        <td class="td01">排名</td>
        <td class="td02">缺陷详情</td>
        <td class="td03">数量</td>
        <td class="td04">占比</td>
        </tr>`
    for(let i = 0;i < data.length;i++){
        strAll += `
            <tr>
                <td style="text-align:center;"><i style="background:${i < 3?'#bea571':'#eff3fc'};color:${i < 3?'#fff':'#999'};">${i+1}</i></td>
                <td>${data[i].name}</td>
                <td>${data[i].num}</td>
                <td>${data[i].percentStr}</td>
            </tr>
        `
    }
    $(".qtable").html(tmp+strAll)
}
//饼图列表注释渲染
function panDetailB(data){
    let color = ['#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336','#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336'];
    let strAll = '';
    for(let i = 0;i < data.length;i++){
        strAll += `
            <tr class="explainLi">
                <td class="deptName" title="${data[i].name}">
                    <p><i class="tip" style="background-color:${color[i]}"></i>${data[i].name}</p>
                </td>
                <td class="deptNum">${data[i].num}</td>
                <td class="percent">(${data[i].percentStr})</td>
            </tr>
        `
    }
    $(".explainPanB table").html(strAll);
    $(".explainPan").css({
        marginTop:-($(".explainPan").height()/2-20)+'px'
    })
}
function panDetailBc(data){
    let color = ['#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336','#F2637B','#975FE4', '#399FFF', '#37CBCB', '#4CCB73','#FAD336'];
    let strAll = '';
    for(let i = 0;i < data.length;i++){
        strAll += `
            <tr class="explainLi">
                <td class="deptName" title="${data[i].name}">
                    <p><i class="tip" style="background-color:${color[i]}"></i>${data[i].name}</p>
                </td>
                <td class="deptNum">${data[i].num}</td>
                <td class="percent">(${data[i].percentStr})</td>
            </tr>
        `
    }
    $(".explainPanBc table").html(strAll);
    $(".explainPan").css({
        marginTop:-($(".explainPanc").height()/2-20)+'px'
    })
}
//时间获取
function getTimeDetail(){
    const d = new Date();
    const days = ["星期日","星期一","星期二","星期三","星期四","星期五","星期六"];
    let sec = d.getSeconds()
    let min = d.getMinutes()
    let hour = d.getHours()
    let str = `${d.getFullYear()}年${d.getMonth()+1}月${d.getDate()}日 / ${days[d.getDay()]} / ${hour>9?hour:'0'+hour}:${min>9?min:'0'+min}:${sec>9?sec:'0'+sec}`
    $(".dateDetail").html(str)
}


